        subroutine Dmatrix (D)
            use vars
            Implicit Double Precision (A-H,O-Z)
            Real(8) :: D(6,6)

            xG = c(1)
            BFac = (2d0*(1d0+c(2)))/(3d0*(1-2d0*c(2))) ! K/G as function of Nu (Nu=c(2))
            a = c(3)
            phirad = c(4)*pi/180d0
            phirad = atan(tan(phirad)/Msf)
            !alpha = (2d0*sin(phirad))/((sqrt(3d0))*(3d0-sin(phirad))) ! Matching TXC
            !alpha = (2d0*sin(phirad))/((sqrt(3d0))*(3d0+sin(phirad))) ! Matching TXE
            alpha = sin(phirad)/((sqrt(3d0))*(sqrt(3d0+sin(phirad)**2))) ! Tangential inner circle
            psirad = c(5)*pi/180d0
            if (psirad.gt.phirad) then
                psirad = phirad
            end if
            !alphaQ = (2d0*sin(psirad))/((sqrt(3d0))*(3d0-sin(psirad))) ! Matching TXC
            !alphaQ = (2d0*sin(psirad))/((sqrt(3d0))*(3d0+sin(psirad))) ! Matching TXE
            alphaQ =sin(psirad)/((sqrt(3d0))*(sqrt(3d0+sin(psirad)**2))) ! Tangential inner circle
            xky = 3d0*alpha*a

            do i =1, 6
                    do j = 1,6
                        Dm(i,j) =0d0
                    end do
            end do

            do i =1, 3
                    do j = 1,3
                        Dm(i,j) = (BFac - 2d0/3d0)*xG
                    end do
                    Dm(i,i) = (BFac + 4d0/3d0)*xG
                    Dm (i+3,i+3) = xG
            end do

            D = Dm


        end subroutine

        subroutine calcstrinv(Si)
            use vars
            Implicit Double Precision (A-H,O-Z)
            real(8) :: Si1, Si2, Si3, xN1(3), xN2(3), xN3(3)
            real(8), dimension(6), intent(in) :: Si
            integer iOpt

            iOpt = 0
            call PrnSig(iOpt,Si,xN1,xN2,xN3,Si1,Si2,Si3,p,q)
            if (p .lt.(-a)) then
                ipls = 2
            end if
            xJ2=((Si1-Si2)**2d0+(Si2-Si3)**2d0+(Si3-Si1)**2d0)*1d0/6d0 !Calculating J2 from principal stresses

        end subroutine

        subroutine calcond(fs)
            use vars
            Implicit Double Precision (A-H,O-Z)
            double precision, intent(out) :: fs
            double precision :: dSigtr(6), f0, beta

            call calcstrinv(v0(1:6))
            f0 = sqrt(xJ2)-alpha*(p)*3d0-xky ! yield criterion using I1 = 3*p

            call MatVec(Dm,6,de,6,dSigtr) ! Elastic stress increment
            call AddVec(v0(1:6),dSigtr,1d0,-1d0,6,Sigtr) ! Trial stress. Minus sign due to sign convention.
            call calcstrinv(Sigtr)
            fs = sqrt(xJ2)-alpha*(p)*3d0-xky ! yield criterion using I1 = 3*p

            !if (nrabort.eq.0) then

            if (fs.gt.1d-6) then
                if (f0.lt.-1d-6) then
                    beta = f0/(f0-fs)
                    call MulVec(dSigtr,beta,size(dSigtr))
                    call AddVec(v0(1:6),dSigtr,1d0,-1d0,6,vs0(1:6))
                    vs0(7) = v0(7)
                else
                    call CopyRVec(v0,vs0,7)
                end if
            end if

        end subroutine

        subroutine differentials(A0)
            use vars
            Implicit Double Precision (A-H,O-Z)
            double precision, dimension(6), intent(out) :: A0
            double precision :: pd,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12
            double precision :: t13,t14,t15,t16,t17,t18,t19,t20,t21,t22
            double precision :: sig11,sig22 ,sig33,sig12,sig23,sig31

                call MZeroR(A0,6)
                sig11 = vs(1)
                sig22 = vs(2)
                sig33 = vs(3)
                sig12 = vs(4)
                sig23 = vs(5)
                sig31 = vs(6)


                  t2 = sig22*(1.0D0/3.0D0)
                  t4 = sig11*(1.0D0/3.0D0)
                  t9 = sig33*(2.0D0/3.0D0)
                  t3 = t2+t4-t9
                  t5 = sig33*(1.0D0/3.0D0)
                  t8 = sig22*(2.0D0/3.0D0)
                  t6 = t4+t5-t8
                  t14 = sig11*(2.0D0/3.0D0)
                  t7 = t2+t5-t14
                  t10 = t3**2
                  t11 = t10*(1.0D0/2.0D0)
                  t12 = t6**2
                  t13 = t12*(1.0D0/2.0D0)
                  t15 = t7**2
                  t16 = t15*(1.0D0/2.0D0)
                  t17 = sig12**2
                  t18 = sig23**2
                  t19 = sig31**2
                  t20 = t11+t13+t16+t17+t18+t19 ! t20 = xJ2
                    if (t20.lt.1d-6) then
                    t20 = 1d-6
                    end if
                  t21 = 1.0D0/sqrt(t20)
                  A0(1) = -alphaQ-t7*t21*(1.0D0/2.0D0)
                  A0(2) = -alphaQ-t6*t21*(1.0D0/2.0D0)
                  A0(3) = -alphaQ-t3*t21*(1.0D0/2.0D0)
                  A0(4) = sig12*t21
                  A0(5) = sig23*t21
                  A0(6) = sig31*t21


        end subroutine

        subroutine resi(rr)
            use vars
            Implicit Double Precision (A-H,O-Z)
            double precision, dimension(6) :: depspl, diffsigsigtr
            double precision, dimension(6) :: deltasig, dQdsig
            double precision, dimension(7), intent(out) :: rr

            call MZeroR(rr,7)
            call MZeroR(diffsigsigtr,6)
            call MZeroR(dQdsig,6)
            call MZeroR(depspl,6)
            call MZeroR(deltasig,6)

            call AddVec(vs(1:6),Sigtr,1d0,-1d0,6,diffsigsigtr)
            call differentials(dQdsig)
            call MatVec(Dm,6,dQdsig,6,depspl)
            call MulVec(depspl,(vs(7)-v0(7)),6)
            call AddVec(diffsigsigtr,depspl,1d0,1d0,6,rr(1:6))

            call calcstrinv(vs(1:6))
            rr(7) = sqrt(xJ2)-alpha*(p)*3d0-xky ! yield criterion using I1 = 3*p

        end subroutine

        subroutine jacobian(A0)
            use vars
            Implicit Double Precision (A-H,O-Z)
            double precision, dimension(7,7), intent(out) :: A0
            double precision :: pj,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12
            double precision :: t13,t14,t15,t16,t17,t18,t19,t20,t21,t22
            double precision :: t23,t24,t25,t26,t27,t28,t29,t30,t50,t31
            double precision :: t32,t33,t34,t53,t35,t36,t37,t56,t38,t39
            double precision :: t40,t41,t42 t43,t44,t45,t46,t47,t48,t49
            double precision :: t51,t52,t54,t55,t57,t58,t59,t60,t61,t62
            double precision :: t63,t64,t65,t66,t67,t68
            double precision :: sig11,sig22 ,sig33,sig12,sig23,sig31
            double precision :: xlam,xlam0,xK

        sig11 = vs(1)
        sig22 = vs(2)
        sig33 = vs(3)
        sig12 = vs(4)
        sig23 = vs(5)
        sig31 = vs(6)
        xlam  = vs(7)
        xlam0 = v0(7)
        xK = BFac*xG


      t3 = sig11*(1.0D0/3.0D0)
      t5 = sig22*(1.0D0/3.0D0)
      t8 = sig33*(2.0D0/3.0D0)
      t2 = t3+t5-t8
      t6 = sig33*(1.0D0/3.0D0)
      t12 = sig22*(2.0D0/3.0D0)
      t4 = t3+t6-t12
      t9 = sig11*(2.0D0/3.0D0)
      t7 = t5+t6-t9
      t10 = t2**2
      t11 = t10*(1.0D0/2.0D0)
      t13 = t4**2
      t14 = t13*(1.0D0/2.0D0)
      t15 = t7**2
      t16 = t15*(1.0D0/2.0D0)
      t17 = sig12**2
      t18 = sig23**2
      t19 = sig31**2
      t20 = t11+t14+t16+t17+t18+t19 ! t20 = xJ2
        if (t20.lt.1d-6) then
        t20 = 1d-6
        end if
      t21 = xG*(2.0D0/3.0D0)
      t22 = t21-xK
      t23 = 1.0D0/sqrt(t20)
      t24 = t23*(1.0D0/6.0D0)
      t25 = 1.0D0/t20**(3.0D0/2.0D0)
      t26 = xlam-xlam0
      t27 = t23*(1.0D0/3.0D0)
      t28 = xG*(4.0D0/3.0D0)
      t29 = t28+xK
      t30 = t4*t7*t25*(1.0D0/4.0D0)
      t31 = t24+t30
      t32 = t2*t4*t25*(1.0D0/4.0D0)
      t33 = t24+t32
      t34 = t2*t7*t25*(1.0D0/4.0D0)
      t35 = t24+t34
      t36 = t22*t35
      t52 = t15*t25*(1.0D0/4.0D0)
      t37 = t27-t52
      t38 = t29*t31
      t39 = t22*t31
      t59 = t10*t25*(1.0D0/4.0D0)
      t40 = t27-t59
      t41 = t22*t40
      t42 = sig12*t2*t22*t25*(1.0D0/2.0D0)
      t43 = sig23*t2*t22*t25*(1.0D0/2.0D0)
      t44 = sig31*t2*t22*t25*(1.0D0/2.0D0)
      t45 = t4*t23*(1.0D0/2.0D0)
      t46 = alphaQ+t45
      t47 = t2*t23*(1.0D0/2.0D0)
      t48 = alphaQ+t47
      t49 = t22*t48
      t50 = t7*t23*(1.0D0/2.0D0)
      t51 = alphaQ+t50
      t53 = t22*t37
      t54 = t29*t35
      t55 = t27-t13*t25*(1.0D0/4.0D0)
      t56 = t22*t55
      t57 = t29*t33
      t58 = t22*t33
      t60 = sig12*t4*t22*t25*(1.0D0/2.0D0)
      t61 = sig12*t7*t22*t25*(1.0D0/2.0D0)
      t62 = sig23*t4*t22*t25*(1.0D0/2.0D0)
      t63 = sig23*t7*t22*t25*(1.0D0/2.0D0)
      t64 = sig31*t4*t22*t25*(1.0D0/2.0D0)
      t65 = sig31*t7*t22*t25*(1.0D0/2.0D0)
      t66 = t22*t46
      t67 = t22*t51
      t68 = t23*t26*xG
      A0(1,1) = t26*(t36+t39+t29*t37)+1.0D0
      A0(1,2) = -t26*(t38+t56-t22*t33)
      A0(1,3) = -t26*(t41+t54-t22*t33)
      A0(1,4) = -t26*(t42+t60-sig12*t7*t25*t29*(1.0D0/2.0D0))
      A0(1,5) = -t26*(t43+t62-sig23*t7*t25*t29*(1.0D0/2.0D0))
      A0(1,6) = -t26*(t44+t64-sig31*t7*t25*t29*(1.0D0/2.0D0))
      A0(1,7) = t49+t66-t29*t51
      A0(2,1) = -t26*(-t36+t38+t53)
      A0(2,2) = t26*(t39+t58+t29*t55)+1.0D0
      A0(2,3) = -t26*(-t36+t41+t57)
      A0(2,4) = -t26*(t42+t61-sig12*t4*t25*t29*(1.0D0/2.0D0))
      A0(2,5) = -t26*(t43+t63-sig23*t4*t25*t29*(1.0D0/2.0D0))
      A0(2,6) = -t26*(t44+t65-sig31*t4*t25*t29*(1.0D0/2.0D0))
      A0(2,7) = t49+t67-t29*t46
      A0(3,1) = -t26*(-t39+t53+t54)
      A0(3,2) = -t26*(-t39+t56+t57)
      A0(3,3) = t26*(t36+t58+t29*(t27-t59))+1.0D0
      A0(3,4) = -t26*(t60+t61-sig12*t2*t25*t29*(1.0D0/2.0D0))
      A0(3,5) = -t26*(t62+t63-sig23*t2*t25*t29*(1.0D0/2.0D0))
      A0(3,6) = -t26*(t64+t65-sig31*t2*t25*t29*(1.0D0/2.0D0))
      A0(3,7) = t66+t67-t29*t48
      A0(4,1) = sig12*t7*t25*t26*xG*(1.0D0/2.0D0)
      A0(4,2) = sig12*t4*t25*t26*xG*(1.0D0/2.0D0)
      A0(4,3) = sig12*t2*t25*t26*xG*(1.0D0/2.0D0)
      A0(4,4) = t68-t17*t25*t26*xG+1.0D0
      A0(4,5) = -sig12*sig23*t25*t26*xG
      A0(4,6) = -sig12*sig31*t25*t26*xG
      A0(4,7) = sig12*t23*xG
      A0(5,1) = sig23*t7*t25*t26*xG*(1.0D0/2.0D0)
      A0(5,2) = sig23*t4*t25*t26*xG*(1.0D0/2.0D0)
      A0(5,3) = sig23*t2*t25*t26*xG*(1.0D0/2.0D0)
      A0(5,4) = -sig12*sig23*t25*t26*xG
      A0(5,5) = t68-t18*t25*t26*xG+1.0D0
      A0(5,6) = -sig23*sig31*t25*t26*xG
      A0(5,7) = sig23*t23*xG
      A0(6,1) = sig31*t7*t25*t26*xG*(1.0D0/2.0D0)
      A0(6,2) = sig31*t4*t25*t26*xG*(1.0D0/2.0D0)
      A0(6,3) = sig31*t2*t25*t26*xG*(1.0D0/2.0D0)
      A0(6,4) = -sig12*sig31*t25*t26*xG
      A0(6,5) = -sig23*sig31*t25*t26*xG
      A0(6,6) = t68-t19*t25*t26*xG+1.0D0
      A0(6,7) = sig31*t23*xG
      A0(7,1) = -alpha-t50
      A0(7,2) = -alpha-t45
      A0(7,3) = -alpha-t47
      A0(7,4) = sig12*t23
      A0(7,5) = sig23*t23
      A0(7,6) = sig31*t23
      A0(7,7) = 0d0



        end subroutine
