
        subroutine alfcalc()
            use vars
            Implicit Double Precision (A-H,O-Z)
            double precision :: sinrho

            sinrho = (H0*vs(7))/(1d0+H0*vs(7)/sin(phirad))

            alpha = (2d0*sinrho)/((sqrt(3d0))*(3d0-sinrho)) ! Matching TXC
            !alpha = (2d0*sinrho)/((sqrt(3d0))*(3d0+sinrho)) ! Matching TXE
            !alpha = sinrho/((sqrt(3d0))*(sqrt(3d0+sinrho**2))) ! Tangential inner circle

            xky = 3d0*alpha*Coh/(tan(phirad))

        end subroutine

        subroutine Dmatrix (D)
            use vars
            Implicit Double Precision (A-H,O-Z)
            Real(8) :: D(6,6)



            xG = c(1)
            BFac = (2d0*(1d0+c(2)))/(3d0*(1-2d0*c(2))) ! K/G as function of Nu (Nu=c(2))
            a = c(3)
            phirad = c(4)*pi/180d0
            phirad = atan(tan(phirad)/Msf)
            psirad = c(5)*pi/180d0
            if (psirad.gt.phirad) then
                psirad = phirad
            end if
            sinpsi0 = sin(psirad)
            xky = 3d0*alpha*a
            H0 = c(6)
            pref = c(7)

            do i =1, 6
                    do j = 1,6
                        Dm(i,j) =0d0
                    end do
            end do

            do i =1, 3
                    do j = 1,3
                        Dm(i,j) = (BFac - 2d0/3d0)*xG
                    end do
                    Dm(i,i) = (BFac + 4d0/3d0)*xG
                    Dm (i+3,i+3) = xG
            end do

            D = Dm

        end subroutine

        subroutine calcstrinv(Si)
            use vars
            Implicit Double Precision (A-H,O-Z)
            real(8) :: Si1, Si2, Si3, xN1(3), xN2(3), xN3(3)
            real(8), dimension(6), intent(in) :: Si
            integer iOpt

            iOpt = 0
            call PrnSig(iOpt,Si,xN1,xN2,xN3,Si1,Si2,Si3,p,q)
            if (p .lt.(-a)) then
                ipls = 2
            end if
            xJ2=((Si1-Si2)**2d0+(Si2-Si3)**2d0+(Si3-Si1)**2d0)*1d0/6d0 !Calculating J2 from principal stresses

        end subroutine

        subroutine calcond(fs)
            use vars
            Implicit Double Precision (A-H,O-Z)
            double precision, intent(out) :: fs
            double precision, dimension(6) :: dSigtr

            call calcstrinv(v0(1:6))
            call alfcalc()
            f0 = sqrt(xJ2)-alpha*(p)*3d0-xky ! yield criterion using I1 = 3*p

            call MatVec(Dm,6,de,6,dSigtr) ! Elastic stress increment
            call AddVec(v0(1:6),dSigtr,1d0,-1d0,6,Sigtr) ! Trial stress. Minus sign due to sign convention.
            call calcstrinv(Sigtr)
            call alfcalc()
            fs = sqrt(xJ2)-alpha*(p)*3d0-xky ! yield criterion using I1 = 3*p

            !if (nrabort.eq.0) then

            if (fs.gt.1d-6) then
                if (f0.lt.-1d-6) then
                    beta = f0/(f0-fs)
                    call MulVec(dSigtr,beta,size(dSigtr))
                    call AddVec(v0(1:6),dSigtr,1d0,-1d0,6,vs0(1:6))
                    vs0(7) = v0(7)
                else
                    call CopyRVec(v0,vs0,7)
                end if
            end if

        end subroutine


        subroutine differentials(A0)
            use vars
            Implicit Double Precision (A-H,O-Z)
            double precision, dimension(6), intent(out) :: A0
            double precision :: sig11,sig22,sig33,sig12,sig23,sig31
            double precision :: t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12
            double precision :: t13,t14,t15,t16,t17,t18,t19,t20,t21,t22
            double precision :: t23,t24,t25,t26,t27,t28,t29,t30,t31,t32
            double precision :: t33,t34

                  call MZeroR(A0,6)

                  sig11 = vs(1)
                  sig22 = vs(2)
                  sig33 = vs(3)
                  sig12 = vs(4)
                  sig23 = vs(5)
                  sig31 = vs(6)


      t2 = sig22*(1.0D0/3.0D0)
      t4 = sig11*(1.0D0/3.0D0)
      t17 = sig33*(2.0D0/3.0D0)
      t3 = t2+t4-t17
      t5 = sig33*(1.0D0/3.0D0)
      t16 = sig22*(2.0D0/3.0D0)
      t6 = t4+t5-t16
      t22 = sig11*(2.0D0/3.0D0)
      t7 = t2+t5-t22
      t8 = 1.0D0/pref
      t9 = t2+t4+t5
      t10 = t8*t9
      t11 = t10-1.0D0
      t12 = sqrt(3.0D0)
      t13 = sinpsi0*t11
      t14 = t13+3.0D0
      t15 = 1.0D0/t14
      t18 = t3**2
      t19 = t18*(1.0D0/2.0D0)
      t20 = t6**2
      t21 = t20*(1.0D0/2.0D0)
      t23 = t7**2
      t24 = t23*(1.0D0/2.0D0)
      t25 = sig12**2
      t26 = sig23**2
      t27 = sig31**2
      t28 = t19+t21+t24+t25+t26+t27 ! t28 = xJ2
      if (abs(t28).lt.1d-6) then
        t28 = 1d-6
      end if
      t29 = 1.0D0/sqrt(t28)
      t30 = sinpsi0*t11*t12*t15*(2.0D0/3.0D0)
      t31 = sinpsi0*t8*t9*t12*t15*(2.0D0/3.0D0)
      t32 = sinpsi0**2
      t33 = 1.0D0/t14**2
      A0(1) = t30+t31-t7*t29*(1.0D0/2.0D0)-t8*t9*t11*t12*t32*t33*(2.0D
     +0/3.0D0)
      A0(2) = t30+t31-t6*t29*(1.0D0/2.0D0)-t8*t9*t11*t12*t32*t33*(2.0D
     +0/3.0D0)
      A0(3) = t30+t31-t3*t29*(1.0D0/2.0D0)-t8*t9*t11*t12*t32*t33*(2.0D
     +0/3.0D0)
      A0(4) = sig12*t29
      A0(5) = sig23*t29
      A0(6) = sig31*t29



        end subroutine

         subroutine resi(rr)
            use vars
            Implicit Double Precision (A-H,O-Z)
            double precision, dimension(6) :: depspl, diffsigsigtr
            double precision, dimension(6) :: deltasig, dqdsig
            double precision, dimension(7), intent(out) :: rr

            call MZeroR(rr,7)
            call MZeroR(diffsigsigtr,6)
            call MZeroR(dqdsig,6)
            call MZeroR(depspl,6)
            call MZeroR(deltasig,6)

            call AddVec(vs(1:6),Sigtr,1d0,-1d0,6,diffsigsigtr)
            call differentials(dqdsig)
            call MatVec(Dm,6,dqdsig,6,depspl)
            call MulVec(depspl,(vs(7)-v0(7)),6)
            call AddVec(diffsigsigtr,depspl,1d0,1d0,6,rr(1:6))

            call calcstrinv(vs(1:6))
            call alfcalc()
            rr(7) = sqrt(xJ2)-alpha*(p)*3d0-xky ! yield criterion using I1 = 3*p


        end subroutine


        subroutine jacobian(A0)
            use vars
            Implicit Double Precision (A-H,O-Z)
            double precision, dimension(7,7), intent(out) :: A0
            double precision :: sig11,sig22,sig33,sig12,sig23,sig31,xK
            double precision :: xlam,xlam0
            double precision :: t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12
            double precision :: t13,t14,t15,t16,t17,t18,t19,t20,t21,t22
            double precision :: t23,t24,t25,t26,t27,t28,t29,t30,t50,t31
            double precision :: t32,t33,t34,t53,t35,t36,t37,t56,t38,t39
            double precision :: t40,t41,t42 t43,t44,t45,t46,t47,t48,t49
            double precision :: t51,t52,t54,t55,t57,t58,t59,t60,t61,t62
            double precision :: t63,t64,t65,t66,t67,t68,t69,t70,t71,t72
            double precision :: t73,t74,t75,t76,t77,t78,t79,t80,t81,t82
            double precision :: t83,t84,t85,t86,t87,t88,t89,t90,t91,t92
            double precision :: t93,t94,t95,t96,t97

      sig11 = vs(1)
      sig22 = vs(2)
      sig33 = vs(3)
      sig12 = vs(4)
      sig23 = vs(5)
      sig31 = vs(6)
      xlam  = vs(7)
      xlam0 = v0(7)
      xK = BFac*xG


      t3 = sig11*(1.0D0/3.0D0)
      t5 = sig22*(1.0D0/3.0D0)
      t8 = sig33*(2.0D0/3.0D0)
      t2 = t3+t5-t8
      t6 = sig33*(1.0D0/3.0D0)
      t12 = sig22*(2.0D0/3.0D0)
      t4 = t3+t6-t12
      t9 = sig11*(2.0D0/3.0D0)
      t7 = t5+t6-t9
      t10 = t2**2
      t11 = t10*(1.0D0/2.0D0)
      t13 = t4**2
      t14 = t13*(1.0D0/2.0D0)
      t15 = t7**2
      t16 = t15*(1.0D0/2.0D0)
      t17 = sig12**2
      t18 = sig23**2
      t19 = sig31**2
      t20 = t11+t14+t16+t17+t18+t19
      if (abs(t20).lt.1d-6) then !t20 = J2
        t20 = 1d-6
      end if
      t21 = 1.0D0/pref
      t22 = sqrt(3.0D0)
      t23 = t3+t5+t6
      t24 = t21*t23
      t25 = t24-1.0D0
      t26 = sinpsi0*t25
      t27 = t26+3.0D0
      t28 = sinpsi0**2
      t29 = 1.0D0/t27**2
      t30 = 1.0D0/pref**2
      t31 = xG*(2.0D0/3.0D0)
      t32 = t31-xK
      t33 = 1.0D0/sqrt(t20)
      t34 = t33*(1.0D0/6.0D0)
      t35 = 1.0D0/t20**(3.0D0/2.0D0)
      t36 = 1.0D0/t27
      t37 = t22*t23*t28*t29*t30*(4.0D0/9.0D0)
      t38 = t21*t22*t25*t28*t29*(4.0D0/9.0D0)
      t39 = 1.0D0/t27**3
      t40 = xlam-xlam0
      t41 = t33*(1.0D0/3.0D0)
      t42 = xG*(4.0D0/3.0D0)
      t43 = t42+xK
      t44 = t4*t7*t35*(1.0D0/4.0D0)
      t46 = sinpsi0*t21*t22*t36*(4.0D0/9.0D0)
      t47 = sinpsi0*t22*t23*t25*t28*t30*t39*(4.0D0/9.0D0)
      t45 = t34+t37+t38+t44-t46-t47
      t48 = t2*t7*t35*(1.0D0/4.0D0)
      t49 = t2*t4*t35*(1.0D0/4.0D0)
      t50 = t34+t37+t38-t46-t47+t49
      t51 = t32*t50
      t52 = t21*t22*t23*t25*t28*t29*(2.0D0/3.0D0)
      t53 = t15*t35*(1.0D0/4.0D0)
      t54 = t34+t37+t38-t46-t47+t48
      t55 = t32*t45
      t56 = t13*t35*(1.0D0/4.0D0)
      t57 = t10*t35*(1.0D0/4.0D0)
      t58 = t37+t38-t41-t46-t47+t57
      t59 = t32*t58
      t60 = t32*t54
      t61 = sig12*t2*t32*t35*(1.0D0/2.0D0)
      t62 = sig23*t2*t32*t35*(1.0D0/2.0D0)
      t63 = sig31*t2*t32*t35*(1.0D0/2.0D0)
      t64 = t4*t33*(1.0D0/2.0D0)
      t67 = sinpsi0*t22*t25*t36*(2.0D0/3.0D0)
      t68 = sinpsi0*t21*t22*t23*t36*(2.0D0/3.0D0)
      t65 = t52+t64-t67-t68
      t66 = t2*t33*(1.0D0/2.0D0)
      t69 = t7*t33*(1.0D0/2.0D0)
      t70 = t37+t38-t41-t46-t47+t53
      t71 = t32*t70
      t72 = t37+t38-t41-t46-t47+t56
      t73 = sig12*t4*t32*t35*(1.0D0/2.0D0)
      t74 = sig12*t7*t32*t35*(1.0D0/2.0D0)
      t75 = sig23*t4*t32*t35*(1.0D0/2.0D0)
      t76 = sig23*t7*t32*t35*(1.0D0/2.0D0)
      t77 = sig31*t4*t32*t35*(1.0D0/2.0D0)
      t78 = sig31*t7*t32*t35*(1.0D0/2.0D0)
      t79 = t52+t66-t67-t68
      t80 = t32*t65
      t81 = t52-t67-t68+t69
      t82 = t32*t81
      t83 = t33*t40*xG
      t84 = 1.0D0/sin(phirad)
      t85 = H0*t84*xlam
      t86 = t85+1.0D0
      t87 = 1.0D0/t86
      t88 = H0*t87*xlam
      t89 = t88-3.0D0
      t90 = 1.0D0/t89
      t91 = H0*t22*t87*t90*xlam*(2.0D0/3.0D0)
      t92 = H0**2
      t93 = 1.0D0/t86**2
      t94 = 1.0D0/t89**2
      t95 = H0*t87
      t96 = t95-t84*t92*t93*xlam
      A0(1,1) = t40*(t55-t43*(t37+t38-t41+t53-sinpsi0*t21*t22*t36*(4.0D0
     +/9.0D0)-sinpsi0*t22*t23*t25*t28*t30*t39*(4.0D0/9.0D0))+t32*(t34+t3
     +7+t38+t48-sinpsi0*t21*t22*t36*(4.0D0/9.0D0)-sinpsi0*t22*t23*t25*t2
     +8*t30*t39*(4.0D0/9.0D0)))+1.0D0
      A0(1,2) = t40*(t51+t32*(t37+t38-t41+t56-sinpsi0*t21*t22*t36*(4.0D0
     +/9.0D0)-sinpsi0*t22*t23*t25*t28*t30*t39*(4.0D0/9.0D0))-t43*t45)
      A0(1,3) = t40*(t51+t59-t43*t54)
      A0(1,4) = -t40*(t61+t73-sig12*t7*t35*t43*(1.0D0/2.0D0))
      A0(1,5) = -t40*(t62+t75-sig23*t7*t35*t43*(1.0D0/2.0D0))
      A0(1,6) = -t40*(t63+t77-sig31*t7*t35*t43*(1.0D0/2.0D0))
      A0(1,7) = t80+t32*(t52+t66-sinpsi0*t22*t25*t36*(2.0D0/3.0D0)-sinps
     +i0*t21*t22*t23*t36*(2.0D0/3.0D0))-t43*(t52+t69-sinpsi0*t22*t25*t36
     +*(2.0D0/3.0D0)-sinpsi0*t21*t22*t23*t36*(2.0D0/3.0D0))
      A0(2,1) = t40*(t60+t71-t43*t45)
      A0(2,2) = t40*(t51+t55-t43*t72)+1.0D0
      A0(2,3) = t40*(t59+t60-t43*t50)
      A0(2,4) = -t40*(t61+t74-sig12*t4*t35*t43*(1.0D0/2.0D0))
      A0(2,5) = -t40*(t62+t76-sig23*t4*t35*t43*(1.0D0/2.0D0))
      A0(2,6) = -t40*(t63+t78-sig31*t4*t35*t43*(1.0D0/2.0D0))
      A0(2,7) = t82-t43*t65+t32*t79
      A0(3,1) = t40*(t55+t71-t43*t54)
      A0(3,2) = t40*(t55-t43*t50+t32*t72)
      A0(3,3) = t40*(t51+t60-t43*t58)+1.0D0
      A0(3,4) = -t40*(t73+t74-sig12*t2*t35*t43*(1.0D0/2.0D0))
      A0(3,5) = -t40*(t75+t76-sig23*t2*t35*t43*(1.0D0/2.0D0))
      A0(3,6) = -t40*(t77+t78-sig31*t2*t35*t43*(1.0D0/2.0D0))
      A0(3,7) = t80+t82-t43*t79
      A0(4,1) = sig12*t7*t35*t40*xG*(1.0D0/2.0D0)
      A0(4,2) = sig12*t4*t35*t40*xG*(1.0D0/2.0D0)
      A0(4,3) = sig12*t2*t35*t40*xG*(1.0D0/2.0D0)
      A0(4,4) = t83-t17*t35*t40*xG+1.0D0
      A0(4,5) = -sig12*sig23*t35*t40*xG
      A0(4,6) = -sig12*sig31*t35*t40*xG
      A0(4,7) = sig12*t33*xG
      A0(5,1) = sig23*t7*t35*t40*xG*(1.0D0/2.0D0)
      A0(5,2) = sig23*t4*t35*t40*xG*(1.0D0/2.0D0)
      A0(5,3) = sig23*t2*t35*t40*xG*(1.0D0/2.0D0)
      A0(5,4) = -sig12*sig23*t35*t40*xG
      A0(5,5) = t83-t18*t35*t40*xG+1.0D0
      A0(5,6) = -sig23*sig31*t35*t40*xG
      A0(5,7) = sig23*t33*xG
      A0(6,1) = sig31*t7*t35*t40*xG*(1.0D0/2.0D0)
      A0(6,2) = sig31*t4*t35*t40*xG*(1.0D0/2.0D0)
      A0(6,3) = sig31*t2*t35*t40*xG*(1.0D0/2.0D0)
      A0(6,4) = -sig12*sig31*t35*t40*xG
      A0(6,5) = -sig23*sig31*t35*t40*xG
      A0(6,6) = t83-t19*t35*t40*xG+1.0D0
      A0(6,7) = sig31*t33*xG
      A0(7,1) = -t69+t91
      A0(7,2) = -t64+t91
      A0(7,3) = -t66+t91
      A0(7,4) = sig12*t33
      A0(7,5) = sig23*t33
      A0(7,6) = sig31*t33
      A0(7,7) = H0*a*t22*t87*t90*2.0D0+H0*t22*t23*t87*t90*2.0D0-H0*a*t22
     +*t87*t94*t96*xlam*2.0D0-H0*t22*t23*t87*t94*t96*xlam*2.0D0-a*t22*t8
     +4*t90*t92*t93*xlam*2.0D0-t22*t23*t84*t90*t92*t93*xlam*2.0D0

        end subroutine

