
        subroutine alfcalc()
            use vars
            Implicit Double Precision (A-H,O-Z)
            double precision :: sinrho

            sinrho = (H0*vs(7))/(1d0+H0*vs(7)/sin(phirad))

            alpha = (2d0*sinrho)/((sqrt(3d0))*(3d0-sinrho)) ! Matching TXC
            !alpha = (2d0*sinrho)/((sqrt(3d0))*(3d0+sinrho)) ! Matching TXE
            !alpha = sinrho/((sqrt(3d0))*(sqrt(3d0+sinrho**2))) ! Tangential inner circle

            xky = 3d0*alpha*Coh/(tan(phirad))

        end subroutine

        subroutine Dmatrix (D)
            use vars
            Implicit Double Precision (A-H,O-Z)
            Real(8) :: D(6,6)



            xG = c(1)
            BFac = (2d0*(1d0+c(2)))/(3d0*(1-2d0*c(2))) ! K/G as function of Nu (Nu=c(2))
            a = c(3)
            phirad = c(4)*pi/180d0
            phirad = atan(tan(phirad)/Msf)
            psirad = c(5)*pi/180d0
            if (psirad.gt.phirad) then
                psirad = phirad
            end if
            sinpsi0 = sin(psirad)
            xky = 3d0*alpha*a
            H0 = c(6)
            pref = c(7)

            do i =1, 6
                    do j = 1,6
                        Dm(i,j) =0d0
                    end do
            end do

            do i =1, 3
                    do j = 1,3
                        Dm(i,j) = (BFac - 2d0/3d0)*xG
                    end do
                    Dm(i,i) = (BFac + 4d0/3d0)*xG
                    Dm (i+3,i+3) = xG
            end do

            D = Dm

        end subroutine

        subroutine calcstrinv(Si)
            use vars
            Implicit Double Precision (A-H,O-Z)
            real(8) :: Si1, Si2, Si3, xN1(3), xN2(3), xN3(3)
            real(8), dimension(6), intent(in) :: Si
            integer iOpt

            iOpt = 0
            call PrnSig(iOpt,Si,xN1,xN2,xN3,Si1,Si2,Si3,p,q)
            if (p .lt.(-a)) then
                ipls = 2
            end if
            xJ2=((Si1-Si2)**2d0+(Si2-Si3)**2d0+(Si3-Si1)**2d0)*1d0/6d0 !Calculating J2 from principal stresses

        end subroutine

        subroutine calcond(fs)
            use vars
            Implicit Double Precision (A-H,O-Z)
            double precision, intent(out) :: fs
            double precision, dimension(6) :: dSigtr

            call calcstrinv(v0(1:6))
            call alfcalc()
            f0 = sqrt(xJ2)-alpha*(p)*3d0-xky ! yield criterion using I1 = 3*p

            call MatVec(Dm,6,de,6,dSigtr) ! Elastic stress increment
            call AddVec(v0(1:6),dSigtr,1d0,-1d0,6,Sigtr) ! Trial stress. Minus sign due to sign convention.
            call calcstrinv(Sigtr)
            call alfcalc()
            fs = sqrt(xJ2)-alpha*(p)*3d0-xky ! yield criterion using I1 = 3*p

            !if (nrabort.eq.0) then

            if (fs.gt.1d-6) then
                if (f0.lt.-1d-6) then
                    beta = f0/(f0-fs)
                    call MulVec(dSigtr,beta,size(dSigtr))
                    call AddVec(v0(1:6),dSigtr,1d0,-1d0,6,vs0(1:6))
                    vs0(7) = v0(7)
                else
                    call CopyRVec(v0,vs0,7)
                end if
            end if

        end subroutine


        subroutine differentials(A0)
            use vars
            Implicit Double Precision (A-H,O-Z)
            double precision, dimension(6), intent(out) :: A0
            double precision :: sig11,sig22,sig33,sig12,sig23,sig31
            double precision :: t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12
            double precision :: t13,t14,t15,t16,t17,t18,t19,t20,t21,t22
            double precision :: t23,t24,t25,t26,t27,t28,t29,t30,t31,t32
            double precision :: t33,t34

                  call MZeroR(A0,6)

                  sig11 = vs(1)
                  sig22 = vs(2)
                  sig33 = vs(3)
                  sig12 = vs(4)
                  sig23 = vs(5)
                  sig31 = vs(6)


      t2 = sig22*(1.0D0/3.0D0)
      t4 = sig11*(1.0D0/3.0D0)
      t14 = sig33*(2.0D0/3.0D0)
      t3 = t2+t4-t14
      t5 = sig33*(1.0D0/3.0D0)
      t13 = sig22*(2.0D0/3.0D0)
      t6 = t4+t5-t13
      t19 = sig11*(2.0D0/3.0D0)
      t7 = t2+t5-t19
      t8 = sqrt(3.0D0)
      t9 = 1.0D0/pref
      t10 = sinpsi0-3.0D0
      t11 = 1.0D0/t10
      t12 = t2+t4+t5
      t15 = t3**2
      t16 = t15*(1.0D0/2.0D0)
      t17 = t6**2
      t18 = t17*(1.0D0/2.0D0)
      t20 = t7**2
      t21 = t20*(1.0D0/2.0D0)
      t22 = sig12**2
      t23 = sig23**2
      t24 = sig31**2
      t25 = t16+t18+t21+t22+t23+t24 ! t25 = xJ2
      if (abs(t25).lt.1d-6) then
        t25 = 1d-6
      end if
      t26 = 1.0D0/sqrt(t25)
      t27 = t9*t12*(1.0D0/2.0D0)
      t28 = t27-1.0D0
      A0(1) = t7*t26*(-1.0D0/2.0D0)-sinpsi0*t8*t11*t28*(2.0D0/3.0D0)-s
     +inpsi0*t8*t9*t11*t12*(1.0D0/3.0D0)
      A0(2) = t6*t26*(-1.0D0/2.0D0)-sinpsi0*t8*t11*t28*(2.0D0/3.0D0)-s
     +inpsi0*t8*t9*t11*t12*(1.0D0/3.0D0)
      A0(3) = t3*t26*(-1.0D0/2.0D0)-sinpsi0*t8*t11*t28*(2.0D0/3.0D0)-s
     +inpsi0*t8*t9*t11*t12*(1.0D0/3.0D0)
      A0(4) = sig12*t26
      A0(5) = sig23*t26
      A0(6) = sig31*t26




        end subroutine

         subroutine resi(rr)
            use vars
            Implicit Double Precision (A-H,O-Z)
            double precision, dimension(6) :: depspl, diffsigsigtr
            double precision, dimension(6) :: deltasig, dqdsig
            double precision, dimension(7), intent(out) :: rr

            call MZeroR(rr,7)
            call MZeroR(diffsigsigtr,6)
            call MZeroR(dqdsig,6)
            call MZeroR(depspl,6)
            call MZeroR(deltasig,6)

            call AddVec(vs(1:6),Sigtr,1d0,-1d0,6,diffsigsigtr)
            call differentials(dqdsig)
            call MatVec(Dm,6,dqdsig,6,depspl)
            call MulVec(depspl,(vs(7)-v0(7)),6)
            call AddVec(diffsigsigtr,depspl,1d0,1d0,6,rr(1:6))

            call calcstrinv(vs(1:6))
            call alfcalc()
            rr(7) = sqrt(xJ2)-alpha*(p)*3d0-xky ! yield criterion using I1 = 3*p


        end subroutine


        subroutine jacobian(A0)
            use vars
            Implicit Double Precision (A-H,O-Z)
            double precision, dimension(7,7), intent(out) :: A0
            double precision :: sig11,sig22,sig33,sig12,sig23,sig31,xK
            double precision :: xlam,xlam0
            double precision :: t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12
            double precision :: t13,t14,t15,t16,t17,t18,t19,t20,t21,t22
            double precision :: t23,t24,t25,t26,t27,t28,t29,t30,t50,t31
            double precision :: t32,t33,t34,t53,t35,t36,t37,t56,t38,t39
            double precision :: t40,t41,t42 t43,t44,t45,t46,t47,t48,t49
            double precision :: t51,t52,t54,t55,t57,t58,t59,t60,t61,t62
            double precision :: t63,t64,t65,t66,t67,t68,t69,t70,t71,t72
            double precision :: t73,t74,t75,t76,t77,t78,t79,t80,t81,t82
            double precision :: t83,t84,t85,t86,t87,t88,t89,t90,t91,t92
            double precision :: t93,t94,t95,t96,t97

      sig11 = vs(1)
      sig22 = vs(2)
      sig33 = vs(3)
      sig12 = vs(4)
      sig23 = vs(5)
      sig31 = vs(6)
      xlam  = vs(7)
      xlam0 = v0(7)
      xK = BFac*xG


      t3 = sig11*(1.0D0/3.0D0)
      t5 = sig22*(1.0D0/3.0D0)
      t8 = sig33*(2.0D0/3.0D0)
      t2 = t3+t5-t8
      t6 = sig33*(1.0D0/3.0D0)
      t12 = sig22*(2.0D0/3.0D0)
      t4 = t3+t6-t12
      t9 = sig11*(2.0D0/3.0D0)
      t7 = t5+t6-t9
      t10 = t2**2
      t11 = t10*(1.0D0/2.0D0)
      t13 = t4**2
      t14 = t13*(1.0D0/2.0D0)
      t15 = t7**2
      t16 = t15*(1.0D0/2.0D0)
      t17 = sig12**2
      t18 = sig23**2
      t19 = sig31**2
      t20 = t11+t14+t16+t17+t18+t19
      if (abs(t20).lt.1d-6) then !t20 = J2
        t20 = 1d-6
      end if
      t21 = xG*(2.0D0/3.0D0)
      t22 = t21-xK
      t23 = 1.0D0/sqrt(t20)
      t24 = t23*(1.0D0/6.0D0)
      t25 = 1.0D0/t20**(3.0D0/2.0D0)
      t26 = sqrt(3.0D0)
      t27 = 1.0D0/pref
      t28 = sinpsi0-3.0D0
      t29 = 1.0D0/t28
      t30 = sinpsi0*t26*t27*t29*(2.0D0/9.0D0)
      t31 = xlam-xlam0
      t32 = xG*(4.0D0/3.0D0)
      t33 = t32+xK
      t34 = t4*t7*t25*(1.0D0/4.0D0)
      t35 = t24+t30+t34
      t36 = t2*t7*t25*(1.0D0/4.0D0)
      t37 = t24+t30+t36
      t38 = t2*t4*t25*(1.0D0/4.0D0)
      t39 = t24+t30+t38
      t40 = t22*t39
      t41 = t3+t5+t6
      t42 = t27*t41*(1.0D0/2.0D0)
      t43 = t42-1.0D0
      t44 = sinpsi0*t26*t29*t43*(2.0D0/3.0D0)
      t45 = sinpsi0*t26*t27*t29*t41*(1.0D0/3.0D0)
      t46 = t22*t37
      t47 = t15*t25*(1.0D0/4.0D0)
      t51 = t23*(1.0D0/3.0D0)
      t48 = t30+t47-t51
      t49 = t22*t35
      t50 = t13*t25*(1.0D0/4.0D0)
      t52 = t10*t25*(1.0D0/4.0D0)
      t53 = sig12*t2*t22*t25*(1.0D0/2.0D0)
      t54 = sig23*t2*t22*t25*(1.0D0/2.0D0)
      t55 = sig31*t2*t22*t25*(1.0D0/2.0D0)
      t56 = t4*t23*(1.0D0/2.0D0)
      t57 = t44+t45+t56
      t58 = t2*t23*(1.0D0/2.0D0)
      t59 = t44+t45+t58
      t60 = t22*t59
      t61 = t7*t23*(1.0D0/2.0D0)
      t62 = t44+t45+t61
      t63 = t22*t48
      t64 = t30+t50-t51
      t65 = t30-t51+t52
      t66 = sig12*t4*t22*t25*(1.0D0/2.0D0)
      t67 = sig12*t7*t22*t25*(1.0D0/2.0D0)
      t68 = sig23*t4*t22*t25*(1.0D0/2.0D0)
      t69 = sig23*t7*t22*t25*(1.0D0/2.0D0)
      t70 = sig31*t4*t22*t25*(1.0D0/2.0D0)
      t71 = sig31*t7*t22*t25*(1.0D0/2.0D0)
      t72 = t22*t57
      t73 = t22*t62
      t74 = t23*t31*xG
      t75 = 1.0D0/sin(phirad)
      t76 = H0*t75*xlam
      t77 = t76+1.0D0
      t78 = 1.0D0/t77
      t79 = H0*t78*xlam
      t80 = t79-3.0D0
      t81 = 1.0D0/t80
      t82 = H0*t26*t78*t81*xlam*(2.0D0/3.0D0)
      t83 = H0**2
      t84 = 1.0D0/t77**2
      t85 = 1.0D0/t80**2
      t86 = H0*t78
      t87 = t86-t75*t83*t84*xlam
      A0(1,1) = t31*(t46+t49-t33*t48)+1.0D0
      A0(1,2) = t31*(t40-t33*t35+t22*(t23*(-1.0D0/3.0D0)+t30+t50))
      A0(1,3) = t31*(t40-t33*t37+t22*(t23*(-1.0D0/3.0D0)+t30+t52))
      A0(1,4) = -t31*(t53+t66-sig12*t7*t25*t33*(1.0D0/2.0D0))
      A0(1,5) = -t31*(t54+t68-sig23*t7*t25*t33*(1.0D0/2.0D0))
      A0(1,6) = -t31*(t55+t70-sig31*t7*t25*t33*(1.0D0/2.0D0))
      A0(1,7) = t60+t72-t33*t62
      A0(2,1) = t31*(t46+t63-t33*t35)
      A0(2,2) = t31*(t40+t49-t33*t64)+1.0D0
      A0(2,3) = t31*(t46-t33*t39+t22*t65)
      A0(2,4) = -t31*(t53+t67-sig12*t4*t25*t33*(1.0D0/2.0D0))
      A0(2,5) = -t31*(t54+t69-sig23*t4*t25*t33*(1.0D0/2.0D0))
      A0(2,6) = -t31*(t55+t71-sig31*t4*t25*t33*(1.0D0/2.0D0))
      A0(2,7) = t60+t73-t33*t57
      A0(3,1) = t31*(t49+t63-t33*t37)
      A0(3,2) = t31*(t49-t33*t39+t22*t64)
      A0(3,3) = t31*(t40+t46-t33*t65)+1.0D0
      A0(3,4) = -t31*(t66+t67-sig12*t2*t25*t33*(1.0D0/2.0D0))
      A0(3,5) = -t31*(t68+t69-sig23*t2*t25*t33*(1.0D0/2.0D0))
      A0(3,6) = -t31*(t70+t71-sig31*t2*t25*t33*(1.0D0/2.0D0))
      A0(3,7) = t72+t73-t33*t59
      A0(4,1) = sig12*t7*t25*t31*xG*(1.0D0/2.0D0)
      A0(4,2) = sig12*t4*t25*t31*xG*(1.0D0/2.0D0)
      A0(4,3) = sig12*t2*t25*t31*xG*(1.0D0/2.0D0)
      A0(4,4) = t74-t17*t25*t31*xG+1.0D0
      A0(4,5) = -sig12*sig23*t25*t31*xG
      A0(4,6) = -sig12*sig31*t25*t31*xG
      A0(4,7) = sig12*t23*xG
      A0(5,1) = sig23*t7*t25*t31*xG*(1.0D0/2.0D0)
      A0(5,2) = sig23*t4*t25*t31*xG*(1.0D0/2.0D0)
      A0(5,3) = sig23*t2*t25*t31*xG*(1.0D0/2.0D0)
      A0(5,4) = -sig12*sig23*t25*t31*xG
      A0(5,5) = t74-t18*t25*t31*xG+1.0D0
      A0(5,6) = -sig23*sig31*t25*t31*xG
      A0(5,7) = sig23*t23*xG
      A0(6,1) = sig31*t7*t25*t31*xG*(1.0D0/2.0D0)
      A0(6,2) = sig31*t4*t25*t31*xG*(1.0D0/2.0D0)
      A0(6,3) = sig31*t2*t25*t31*xG*(1.0D0/2.0D0)
      A0(6,4) = -sig12*sig31*t25*t31*xG
      A0(6,5) = -sig23*sig31*t25*t31*xG
      A0(6,6) = t74-t19*t25*t31*xG+1.0D0
      A0(6,7) = sig31*t23*xG
      A0(7,1) = -t61+t82
      A0(7,2) = -t56+t82
      A0(7,3) = -t58+t82
      A0(7,4) = sig12*t23
      A0(7,5) = sig23*t23
      A0(7,6) = sig31*t23
      A0(7,7) = H0*a*t26*t78*t81*2.0D0+H0*t26*t41*t78*t81*2.0D0-H0*a*t26
     +*t78*t85*t87*xlam*2.0D0-H0*t26*t41*t78*t85*t87*xlam*2.0D0-a*t26*t7
     +5*t81*t83*t84*xlam*2.0D0-t26*t41*t75*t81*t83*t84*xlam*2.0D0


        end subroutine

