clear all

syms sigtr11 sigtr22 sigtr33 sigtr12 sigtr23 sigtr31
syms sig11 sig22 sig33 sig12 sig23 sig31
syms xK xG dQdsig
syms Q F xlam xlam0 alpha alphaQ p pref xJ2 xkf sinpsi
syms v r J sinrho H0 sinphi a sinpsi0 alphaQ0


p = (sig11 +sig22 + sig33)/3;
Sigtr = [sigtr11; sigtr22; sigtr33; sigtr12; sigtr23; sigtr31];
Sig = [sig11; sig22; sig33; sig12; sig23; sig31];
S = Sig - p*[1; 1; 1; 0; 0; 0];

sinrho = H0*xlam/(1+H0*xlam/sinphi);
xJ2 = 0.5*(S(1)^2+S(2)^2+S(3)^2+2*S(4)^2+2*S(5)^2+2*S(6)^2);

alpha = 2*sinrho/(sqrt(3)*(3-sinrho));          %TXC
alphaQ0 = 2*sinpsi0/(sqrt(3)*(3-sinpsi0));      %TXC
%alpha = 2*sinrho/(sqrt(3)*(3+sinrho));          %TXE
%alphaQ0 = 2*sinpsi0/(sqrt(3)*(3+sinpsi0));      %TXE
%alpha = sinrho/(sqrt(3)*sqrt(3+sinrho^2));      %PS
%alphaQ0 = sinpsi0/(sqrt(3)*sqrt(3+sinpsi0^2));  %PS

xkf = 3*alpha*a;		
alphaQ = alphaQ0*(1-p/(2*pref));

v = [Sig;xlam];
F = sqrt(xJ2) - alpha*3*p - xkf;
Q = sqrt(xJ2) - alphaQ*3*p;

for i = 1:3
	for j = 1:3
		D(i,j) = xK -2*xG/3;
	end
	D(i,i) = xK + 4*xG/3;
	D(i+3,i+3) = xG;
end

for i = 1:6
	dQdsig(i,1) = diff(Q,Sig(i));
end

r = [Sig - Sigtr + D*dQdsig*(xlam-xlam0); F];


for i = 1:7
	for j = 1:7
		J(i,j) = diff(r(i),v(j)); %"J = drdv"
	end
end

fortran(J,'file','jac.f')
fortran(dQdsig,'file','dQdsig.f')



