        recursive subroutine NR(vo)
                use vars
                Implicit Double Precision (A-H,O-Z)
                double precision, intent(out) :: vo(7)
                double precision :: dv(7)           ! Temporary vector
                double precision :: Jac(7,7)
                double precision :: tol, dotprod, fac, fp, res
                integer :: itr, maxitr, cnt, nc, recuritr

                ! Initializing subroutine variable
                itr = 0
                tol = 1d-6
                res = 1/tol
                recuritr = 50
                maxitr = recuritr +5
                call CopyRVec(vs0,vs,7)
                call MZeroR(r,7)
                call MZeroR(dv,7)
                cnt = 1

                ! NR-routine
                do while(res.gt.tol)
                    if (itr.le.recuritr) then
                        call jacobian(Jac)
                        call resi(r)
                        call gauss(Jac,-r,dv,size(dv))
                        call AddVec(vs,dv,1d0,1d0,7,vs) ! Adding "previous" vector and temporary vector

                        itr = itr+1
                        dotprod = DInProd(r,r,size(r))
                        res = sqrt(dotprod)
                     else if (itr.gt.recuritr) then ! Recursion loop
                        call prC("Recursion loop entered")
                        call prI(nrabort)
                        if(nrabort.gt.5) then
                            call prC("Recursion aborted")  ! Hjelpefuksjon. Ikke ta med i master
                            stop
                        end if
                        cnt = 2*cnt
                        fac = 1d0/real(cnt,8)
                        call MulVec(de,fac,size(de))
!
                        do nc =1,cnt
                            ipls = 0
                            call calcond(fp)
                            if (fp.gt.1d-6) then
                                call NR(vs)
                            else
                                call CopyRVec(Sigtr,vs(1:6),6)
                                vs(7) = vs0(7)
                            end if
                            call CopyRVec(vs,vs0,size(vs))
                            call CopyRVec(vs,v0,size(vs))
                        end do

                        nrabort = nrabort+1
                        itr = itr+1
                        dotprod = DInProd(r,r,size(r))
                        res = sqrt(dotprod)
                    else if(itr.gt.maxitr) then
                        call prC("No local convergence")       ! Hjelpetekst. Ikke ta med i master
                        stop
                    end if

                    if(itr.gt.4) then
                    write(33,*) itr, res, r, vs0, vs
                    end if


                end do





                ! Storing the result vs to the output vector vo
                call CopyRVec(vs,vo,size(vs))

        end subroutine

        subroutine gauss(a,b,x,n)
        ! This subroutine has been downloaded from http://ww2.odu.edu/~agodunov/computing/programs/index.html
        ! Credits: Alexander L Godunov, Department of Physics, Old Dominion University, Norfolk, VA

        !===========================================================
        ! Solutions to a system of linear equations A*x=b
        ! Method: Gauss elimination (with scaling and pivoting)
        ! Alex G. (November 2009)
        !-----------------------------------------------------------
        ! input ...
        ! a(n,n) - array of coefficients for matrix A
        ! b(n)   - array of the right hand coefficients b
        ! n      - number of equations (size of matrix A)
        ! output ...
        ! x(n)   - solutions
        ! comments ...
        ! the original arrays a(n,n) and b(n) will be destroyed
        ! during the calculation
        !===========================================================
        implicit none
        integer n
        double precision a(n,n), b(n), x(n)
        double precision s(n)
        double precision c, pivot, store
        integer i, j, k, l

        ! step 1: begin forward elimination
        do k=1, n-1

        ! step 2: "scaling"
        ! s(i) will have the largest element from row i
          do i=k,n                       ! loop over rows
            s(i) = 0.0
            do j=k,n                    ! loop over elements of row i
              s(i) = max(s(i),abs(a(i,j)))
            end do
          end do

        ! step 3: "pivoting 1"
        ! find a row with the largest pivoting element
          pivot = abs(a(k,k)/s(k))
          l = k
          do j=k+1,n
            if(abs(a(j,k)/s(j)) > pivot) then
              pivot = abs(a(j,k)/s(j))
              l = j
            end if
          end do

        ! Check if the system has a singular matrix
          if(pivot == 0.0) then
            call prC("The matrix is singular")
            return
          end if

        ! step 4: "pivoting 2" interchange rows k and l (if needed)
        if (l /= k) then
          do j=k,n
             store = a(k,j)
             a(k,j) = a(l,j)
             a(l,j) = store
          end do
          store = b(k)
          b(k) = b(l)
          b(l) = store
        end if

        ! step 5: the elimination (after scaling and pivoting)
           do i=k+1,n
              c=a(i,k)/a(k,k)
              a(i,k) = 0.0
              b(i)=b(i)- c*b(k)
              do j=k+1,n
                 a(i,j) = a(i,j)-c*a(k,j)
              end do
           end do
        end do

        ! step 6: back substiturion
        x(n) = b(n)/a(n,n)
        do i=n-1,1,-1
           c=0.0
           do j=i+1,n
             c= c + a(i,j)*x(j)
           end do
           x(i) = (b(i)- c)/a(i,i)
        end do

        end subroutine gauss